#ifndef __MMC_SPI_H__
#define __MMC_SPI_H__

/* return code */
#define MMC_NO_ERR   0
#define MMC_ERR_HW   1 /* hardware error         */
#define MMC_ERR_CMD0 2 /* CMD0 response error    */
#define MMC_ERR_CMD1 3 /* CMD1 response error    */
#define MMC_ERR_CMD  4 /* Command response error */
#define MMC_ERR_DATA 5 /* Data Response error    */
#define MMC_TIMEOUT  0xff /* Response Timeout    */

/* initialize MMC/SD card with SPI mode */
unsigned char mmc_init_spi(void);

/* Finish MMC/SD card access */
void mmc_disable(void);

/* SPI write sector */
unsigned char spi_write(unsigned long address,unsigned char *data);

/* SPI read sector */
unsigned char spi_read(unsigned long address,unsigned char *data);

#endif
