/*
	NON-Buffer FAT driver
*/



/*
 ****************************************************************************
 *	BOOT SECTOR FORMAT(HDD)
 ****************************************************************************
 */
/* boot sector	*/
typedef struct {
	ubyte	bjump[3];			/* 00:short jump instruction              */
	ubyte	boem_ver[8];		/* 03:OEM name & version                  */
	LE2		bbyte_p_sector;		/* 11:bytes per sector                    */
	ubyte	bsec_p_cluster;		/* 13:sectors per cluster(2**n)           */
	LE2		bres_sectors;		/* 14:reserved sector length(DIR, FAT..)  */
	ubyte	bfats;				/* 16:number of FAT                       */
	LE2		broot_dir_ent;		/* 17:max files of root directory FAT32=0 */
	LE2		bttl_sectors;		/* 19:logical total sectors               */
	ubyte	bdisk_id;			/* 21:media descriptor byte               */
	LE2		bfat_sectors;		/* 22:sector size of FAT          FAT32=0 */
	LE2		bsec_p_track;		/* 24:sector per track                    */
	LE2		bheads;				/* 26:number of head                      */
	LE4		bhidden_sectors;	/* 28:number of hidden sector(?)          */
	LE4		bhuge_sectors;		/* 32:# of sector(if bttl_sectors is 0)   */
#if HDD_FAT32
	union{
		struct {					/* ----- FAT12/FAT16 only -----       */
		ubyte	bdos_drv_no;		/* 36:drive number in DOS             */
		ubyte	brev;				/* 37:                                */
		ubyte	boot_sector_id;		/* 38:indicate boot sector(0x29)      */
		LE4		bvol_id;			/* 39:volume ID number                */
		ubyte	bvol_label[11];		/* 43:volume label                    */
		ubyte	bfs_type[8];		/* 54:file system type                */
		ubyte	brev2[0x1C0];		/* 62:program area                    */
		}FAT16;
		struct {						/* ----- FAT32 only -----             */
		LE4		BPB_FATSz32;		/* 36:sector size of FAT              */
		LE2		BPB_ExtFlags;		/* 40:multi fat.& other flags         */
		LE2		BPB_FSVer;			/* 42:HB=mjr / LB=mnr version (0:0)   */
		LE4		BPB_RootClus;		/* 44:first crustor of root directry  */
		LE2		BPB_FSInfo;			/* 48:Sector number of FSINFO         */
		LE2		BPB_BkBootSec;		/* 50:                                */
		ubyte	BPB_Reserved[12];	/* 52:Sould be 0                      */
		ubyte	BS_DrvNum;			/* 64:                                */
		ubyte	BS_Reserved1;		/* 65:                                */
		ubyte	BS_BootSig;			/* 66:                                */
		LE4		BS_VolID;			/* 67:                                */
		ubyte	BS_VolLab[11];      /* 71:                                */
		ubyte	BS_FilSysType[8];	/* 82:"FAT32   "                      */
		ubyte	BS_Reserved2[420];	/* 90:program area?                   */
		}FAT32;
	}O36;
#else /* FAT32 */
	ubyte	bdos_drv_no;		/* 36:drive number in DOS             */
	ubyte	brev;				/* 37:                                */
	ubyte	boot_sector_id;		/* 38:indicate boot sector(0x29)      */
	LE4		bvol_id;			/* 39:volume ID number                */
	ubyte	bvol_label[11];		/* 43:volume label                    */
	ubyte	bfs_type[8];		/* 54:file system type                */
	ubyte	brev2[0x1C0];		/* 62:program area                    */
#endif /* FAT32 */
	LE2		boot_id;			/* 510:boot ID 0x55:0xaa                  */
} boot_t;



/* get primary pertation */
int getPartation(void)
{
	/* partation table */
	sec_ll = 0;
	sec_lh = 0;
	sec_hl = 0;
	sec_hh = 0;
	open_sector();

	for(i=0;i<0x1be);
		read_byte(); /* rsv */

	/* partation1 */
	read_byte();  /* status : 0=non-bootable,80=botable */
	read_byte();  /* start head   */
	read_byte();  /* start sec &  */
	read_byte();  /*     cylinder [ccccccccccssssss] */
	read_byte();  /* type         */
	read_byte();  /* last head    */
	read_byte();  /* last sec &   */
	read_byte();  /*     cylinder [ccccccccccssssss] */
	/* start absolute sector */
	abs_ll = read_byte();
	abs_lh = read_byte();
	abs_hl = read_byte();
	abs_hh = read_byte();
	/* number of sector */
	nsec_ll = read_byte();
	nsec_lh = read_byte();
	nsec_hl = read_byte();
	nsec_hh = read_byte();
	/* pertation 2,3,4 */
	for(i=0;i<0x10*3);
		read_byte();
	read_byte(); /* 0x55 */
	read_byte(); /* 0xAA */
	/* */
	close_sector();

	/* bpb */
}

